#
# spec file for package openstack-monasca-log-persister
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
# Copyright 2017 Fujitsu LIMITED
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define sname monasca-log-persister
%define username    %{sname}
%define groupname   logstash

%define mlp_cfg_dir %{_sysconfdir}/%{sname}
%define mlp_log_dir /var/log/%{sname}

Name:           openstack-%{sname}
Version:        0.0.1
Release:        3.1
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Url:            https://github.com/FujitsuEnablingSoftwareTechnologyGmbH/
Source0:        %{name}.logrotate
Source1:        %{sname}.conf.sample
Source2:        %{name}.service
Summary:        Persists logs in ElasticSearch 
License:        Apache-2.0
Group:          Monitoring/Tools
BuildRequires:  logstash >= 2.3.0
Requires:       logrotate
Requires:       logstash >= 2.3.0
Provides:       %{sname}

BuildArch:      noarch

%description
Consumes logs from Kafka, prepares them for bulk storage, and stores them into Elasticsearch.

%prep
# no-op

%build
# no-op

%install

# etc
%{__install} -D -m 644 %{S:0} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
%{__install} -D -m 644 %{S:1} %{buildroot}%{mlp_cfg_dir}/%{sname}.conf.sample

# var
%{__install} -d -m 750 %{buildroot}%{mlp_log_dir}

# service file
%{__install} -D -m 644 %{S:2} %{buildroot}%{_unitdir}/%{name}.service
mkdir -p %{buildroot}%{_sbindir}
ln -s /usr/sbin/service %{buildroot}%{_sbindir}/rc%{name}

# sedding...;)
sed -e "
s|__MLP_USER__|%{username}|g;
s|__MLP_GROUP__|%{groupname}|g;
s|__MLP_CONFIG__|%{mlp_cfg_dir}/%{sname}.conf|g;
s|__MLP_LOGDIR__|%{mlp_log_dir}|g;
" -i %{buildroot}%{_unitdir}/%{name}.service 

sed -e "
s|__MLP_USER__|%{username}|g;
s|__MLP_GROUP__|%{groupname}|g;
s|__MLP_LOGDIR__|%{mlp_log_dir}|g;
" -i %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

%pre
groupadd --system %{groupname} 2> /dev/null || :
useradd -r -g %{groupname} \
-d %{_localstatedir}/lib/%{sname} \
-s /sbin/nologin \
-c "user for %{name} service" %{username} 2> /dev/null || :
%service_add_pre %{name}.service

%post
%service_add_post %{name}.service
cat <<EOF

================================================================================
In order to start persisting logs to ElasticSearch following configuration bits
needs to be established:

1) zookeeper nodes addresses
2) elasticsearch nodes addresses
3) name of the topic, monasca-log-transformer sends logs to

Copy sample file to the correct location and make your changes:

1) cp %{mlp_cfg_dir}/%{sname}.conf.sample %{mlp_cfg_dir}/%{sname}.conf
2) vi %{mlp_cfg_dir}/%{sname}.conf

================================================================================

EOF

%preun
%service_del_preun %{name}.service

%postun
%service_del_postun %{name}.service

if [ $1 -eq 0 ] ; then
getent password %{username} > /dev/null
  if [ "$?" == "0" ] ; then
      userdel %{username}
  fi
fi

%files
%defattr(-,root,root)

%{_unitdir}/%{name}.service
%{_sbindir}/rc%{name}

%dir %{mlp_cfg_dir}
%attr(-,%{username},%{groupname}) %dir %{mlp_log_dir}

%config(noreplace) %{mlp_cfg_dir}/%{sname}.conf.sample
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}

%changelog
* Thu Apr  5 2018 tbechtold@suse.com
- Add missing BuildRequires for logstash
* Mon Apr 24 2017 dmueller@suse.com
- remove openstack- prefix from username
* Thu Mar 16 2017 johannes.grassler@suse.com
- Renamed package to openstack-monasca-log-persister
- Fixed permissions
* Mon Feb 13 2017 tomasz.trebski@ts.fujitsu.com
- Replaced %%{word}%% with __{word}__ for sed operation to avoid
  confusion with RPM macros
* Tue Jan  3 2017 tomasz.trebski@ts.fujitsu.com
- Initial version of the package
